# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.PropertyRooms do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :ListingKeyNumeric,
    :RoomArea,
    :RoomKeyNumeric,
    :RoomLength,
    :RoomWidth,
    :ListingId,
    :ListingKey,
    :RoomDescription,
    :RoomDimensions,
    :RoomKey,
    :RoomFeatures,
    :RoomAreaSource,
    :RoomAreaUnits,
    :RoomLengthWidthUnits,
    :RoomType,
    :ModificationTimestamp,
    :Property
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :ListingKeyNumeric => float() | nil,
    :RoomArea => float() | nil,
    :RoomKeyNumeric => float() | nil,
    :RoomLength => float() | nil,
    :RoomWidth => float() | nil,
    :ListingId => String.t | nil,
    :ListingKey => String.t | nil,
    :RoomDescription => String.t | nil,
    :RoomDimensions => String.t | nil,
    :RoomKey => String.t | nil,
    :RoomFeatures => [String.t] | nil,
    :RoomAreaSource => String.t | nil,
    :RoomAreaUnits => String.t | nil,
    :RoomLengthWidthUnits => String.t | nil,
    :RoomType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :Property => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.PropertyRooms do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:Property, :struct, FoyerAPI.Model.Property, options)
  end
end

